plugins {
    alias(libs.plugins.android.application)
    alias(libs.plugins.jetbrains.kotlin.android)

    // https://medium.com/@rowaido.game/implementing-the-room-library-with-jetpack-compose-590d13101fa7
    id("com.google.devtools.ksp")

    // For Room (2024-12-17)
    kotlin("kapt")
}

android {
    namespace = "com.hyperling.expensetracker"
    compileSdk = 34

    defaultConfig {
        applicationId = "com.hyperling.expensetracker"
        minSdk = 24
        targetSdk = 34
        versionCode = 1
        versionName = "1.0"

        testInstrumentationRunner = "androidx.test.runner.AndroidJUnitRunner"
        vectorDrawables {
            useSupportLibrary = true
        }
    }

    buildTypes {
        release {
            isMinifyEnabled = false
            proguardFiles(
                getDefaultProguardFile("proguard-android-optimize.txt"),
                "proguard-rules.pro"
            )
        }
    }
    compileOptions {
        sourceCompatibility = JavaVersion.VERSION_1_8
        targetCompatibility = JavaVersion.VERSION_1_8
    }
    kotlinOptions {
        jvmTarget = "1.8"
    }
    buildFeatures {
        compose = true
    }
    composeOptions {
        kotlinCompilerExtensionVersion = "1.5.1"

        // https://medium.com/@rowaido.game/implementing-the-room-library-with-jetpack-compose-590d13101fa7
        //kotlinCompilerExtensionVersion = "1.5.11"
    }
    packaging {
        resources {
            excludes += "/META-INF/{AL2.0,LGPL2.1}"
        }
    }
}

dependencies {

    implementation(libs.androidx.core.ktx)
    implementation(libs.androidx.lifecycle.runtime.ktx)
    implementation(libs.androidx.activity.compose)
    implementation(platform(libs.androidx.compose.bom))
    implementation(libs.androidx.ui)
    implementation(libs.androidx.ui.graphics)
    implementation(libs.androidx.ui.tooling.preview)
    implementation(libs.androidx.material3)
    testImplementation(libs.junit)
    androidTestImplementation(libs.androidx.junit)
    androidTestImplementation(libs.androidx.espresso.core)
    androidTestImplementation(platform(libs.androidx.compose.bom))
    androidTestImplementation(libs.androidx.ui.test.junit4)
    debugImplementation(libs.androidx.ui.tooling)
    debugImplementation(libs.androidx.ui.test.manifest)

    // https://medium.com/@rowaido.game/implementing-the-room-library-with-jetpack-compose-590d13101fa7
    /* This is crazy? How are people supposed to know how to do this, and especially "fix" it when it doesn't work?
    implementation(libs.androidx.room.runtime)
    implementation(libs.androidx.room.ktx)
    ksp(libs.androidx.room.compiler)

    implementation(libs.androidx.lifecycle.viewmodel.compose)
    */

    // For Room (2024-12-17)
    // https://www.youtube.com/watch?v=bOd3wO0uFr8&themeRefresh=1
    /* build.gradle version * /
    def room_version: String = "2.5.0"
    implementation"androidx.room:room-ktx:$room_version"
    kapt "androidx.room:room-compiler:$room_version"
    // */
    /* build.grade.kts version */
    val room_version: String = "2.5.0"
    implementation("androidx.room:room-ktx:$room_version")
    kapt("androidx.room:room-compiler:$room_version")
    // */
}
